# Copyright (c) 2015, Scott J Maddox. All rights reserved.
# Use of this source code is governed by the BSD-3-Clause
# license that can be found in the LICENSE file.

# This file was generated by `scripts/gen_ifd_pyx.py`.
# Do not edit this file directly, or your changes will be lost.
'''
Inverse Fermi-Dirac integrals.
'''
from fdint cimport _fdint
import numpy

def ifd1h(nu, out=None):
    cdef int num
    if isinstance(nu, numpy.ndarray):
        num = nu.shape[0]
        if out is None:
            out = numpy.empty(num)
        else:
            assert isinstance(out, numpy.ndarray) and out.shape[0] == num
        _fdint.vifd1h(nu, out)
        return out
    else:
        return _fdint.ifd1h(nu)
